grammar Fexpression;

@parser::members{
	private FExpression root = null;
	
	public FExpression getRoot(){
		return this.root;
	}
}


epxression: 
	expr=boolExpression							{ this.root = $expr.node; }
;


boolExpression returns [FExpression node] :
	left=boolExpressionPrior1 					{ $node = $left.node; }
		(	AND andRight=boolExpressionPrior1	{ $node = new And($node,$andRight.node); }
		|	OR  orRight=boolExpressionPrior1	{ $node = new Or($node,$orRight.node); }
		)*
;

boolExpressionPrior1 returns [FExpression node]:  
	  LPAREN expr=boolExpression RPAREN 		{ $node = $expr.node; }
	| TRUE										{ $node = Constant.TRUE; }
	| FALSE										{ $node = Constant.FALSE; }
	| FEATURE									{ $node = new Feature($FEATURE.text); }
	| NOT negExpr=boolExpressionPrior1			{ $node = new Not($negExpr.node); }
;

AND : '&&';
OR : '||';
NOT : '!';

TRUE : 'true';
FALSE : 'false';

LPAREN : '(';
RPAREN : ')';

FEATURE: 
	LETTER (LETTER | DIGIT)* 
;

// Whitespaces -> ignored

NL: 
	'\n' | '\r'
;
 
WS: 
	(' ' | '\t' | NL) { skip(); }
;

fragment LETTER
	:	'A'..'Z' | 'a'..'z' | '_';

fragment DIGIT
	:	'0'..'9';